// Generated by LiveScript 1.5.0
var abbrev, red, add, clone, create, deploy, lint, run, setup, sync, test, fs, marked, TerminalRenderer, map, pkg, path, updateNotifier, commands, commandName, fullCommandName;
abbrev = require('abbrev');
red = require('chalk').red;
add = require('../../exo-add');
clone = require('../../exo-clone');
create = require('../../exo-create');
deploy = require('../../exo-deploy');
lint = require('../../exo-lint');
run = require('../../exo-run');
setup = require('../../exo-setup');
sync = require('../../exo-sync');
test = require('../../exo-test');
fs = require('fs');
marked = require('marked');
TerminalRenderer = require('marked-terminal');
map = require('prelude-ls').map;
pkg = require('../../package.json');
path = require('path');
updateNotifier = require('update-notifier');
updateNotifier({
  pkg: pkg
}).notify();
marked.setOptions({
  renderer: new TerminalRenderer()
});
commands = {
  add: add,
  clone: clone,
  create: create,
  deploy: deploy,
  lint: lint,
  run: run,
  setup: setup,
  sync: sync,
  test: test
};
commandName = process.argv[2];
fullCommandName = completeCommandName(commandName);
if (commandName === 'version') {
  console.log("Exosphere version " + pkg.version);
} else if (commandName === 'help') {
  process.argv.shift();
  help(process.argv[2]);
} else if (!commandName) {
  missingCommand();
} else if (!fullCommandName) {
  unknownCommand(commandName);
} else {
  process.argv.shift();
  commands[fullCommandName]();
}
function completeCommandName(commandName){
  return abbrev(commandNames())[commandName];
}
function missingCommand(){
  console.log(red("Error: missing command\n"));
  return printUsage();
}
function unknownCommand(command){
  console.log(red("Error: unknown command '" + command + "'\n"));
  return printUsage();
}
function printUsage(){
  var usageText;
  usageText = "**Usage: exo <command> [options]**\n\nAvailable commands are:\n  * add     Add a service to an existing application\n  * clone   Download the source code of an application\n  * create  Create a new application or stand-alone service\n  * deploy  Deploy an application to the cloud\n  * lint    Verify the correctness of an application\n  * run     Run an application locally\n  * setup   Prepare a freshly cloned application for running it\n  * sync    Download updates for an application from its Git repository\n  * test    Run the tests for an application or service\n\nUse \"exo <command> help\" or \"exo help <command>\" for more information about a specific command.";
  return console.log(marked(usageText));
}
function help(command){
  if (!command) {
    return missingCommand();
  }
  process.argv.push("help");
  process.argv.shift();
  return commands[command]();
}
function commandNames(){
  return Object.keys(commands);
}