// Generated by LiveScript 1.5.0
var abbrev, application, ref$, red, blue, cyan, fs, path, map, service, entities;
abbrev = require('abbrev');
application = require('./entities/application');
ref$ = require('chalk'), red = ref$.red, blue = ref$.blue, cyan = ref$.cyan;
fs = require('fs');
path = require('path');
map = require('prelude-ls').map;
service = require('./entities/service');
entities = {
  application: application,
  service: service
};
module.exports = function(){
  var entityName, fullEntityName;
  if (process.argv[2] === 'help') {
    return help();
  }
  entityName = process.argv[2];
  if (!entityName) {
    return missingEntity();
  }
  fullEntityName = abbrev(entityNames())[entityName];
  if (!in$(fullEntityName, entityNames())) {
    return unknownCommand(entityName);
  }
  return entities[fullEntityName]();
};
function missingEntity(){
  console.log(red("Error: missing entity for 'create' command\n"));
  return help();
}
function unknownCommand(entity){
  console.log(red("Error: cannot create '" + entity + "'\n"));
  return help();
}
function help(){
  var helpText;
  helpText = "Usage: " + cyan("exo create") + " " + blue("[<entity>]") + "\n\nAvailable entities are:\n\n  * application   Create a new Exosphere application\n    - options: " + blue("[<app-name>] [<app-version>] [<exocom-version>] [<app-description>]") + "\n\n  * service       Create a new service for this application located in the parent directory\n    - options: " + blue("[<service-role>] [<service-type>] [<author>] [<template-name>] [<model-name>] [<description>]");
  return console.log(helpText);
}
function entityNames(){
  return Object.keys(entities);
}
function in$(x, xs){
  var i = -1, l = xs.length >>> 0;
  while (++i < l) if (x === xs[i]) return true;
  return false;
}